/*************************************************
* CBC Mode Header File                           *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_CBC_H__
#define OPENCL_CBC_H__

#include <opencl/modebase.h>
#include <opencl/mode_pad.h>

namespace OpenCL {

/*************************************************
* CBC Encryption                                 *
*************************************************/
class CBC_Encryption : public BlockCipherMode
   {
   public:
      void write(const byte[], u32bit);
      void end_msg();

      CBC_Encryption(BlockCipher*, BlockCipherModePaddingMethod*,
                     const BlockCipher_Key&, const BlockCipherModeIV&);
      CBC_Encryption(const std::string&, const std::string&,
                     const BlockCipher_Key&, const BlockCipherModeIV&);
      ~CBC_Encryption() { delete padder; }
   private:
      const BlockCipherModePaddingMethod* padder;
   };

/*************************************************
* CBC Decryption                                 *
*************************************************/
class CBC_Decryption : public BlockCipherMode
   {
   public:
      void write(const byte[], u32bit);
      void end_msg();
      CBC_Decryption(BlockCipher*, BlockCipherModePaddingMethod*,
                     const BlockCipher_Key&, const BlockCipherModeIV&);
      CBC_Decryption(const std::string&, const std::string&,
                     const BlockCipher_Key&, const BlockCipherModeIV&);
      ~CBC_Decryption() { delete padder; }
   private:
      const BlockCipherModePaddingMethod* padder;
      SecureVector<byte> temp;
   };

}

#endif
