/*************************************************
* CTS Mode Header File                           *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_CTS_H__
#define OPENCL_CTS_H__

#include <opencl/modebase.h>

namespace OpenCL {

/*************************************************
* CTS Encryption                                 *
*************************************************/
class CTS_Encryption : public BlockCipherMode
   {
   public:
      void write(const byte[], u32bit);
      void end_msg();
      CTS_Encryption(BlockCipher*, const BlockCipher_Key&,
                     const BlockCipherModeIV&);
      CTS_Encryption(const std::string&, const BlockCipher_Key&,
                     const BlockCipherModeIV&);
   private:
      void encrypt(const byte[]);
   };

/*************************************************
* CTS Decryption                                 *
*************************************************/
class CTS_Decryption : public BlockCipherMode
   {
   public:
      void write(const byte[], u32bit);
      void end_msg();
      CTS_Decryption(BlockCipher*, const BlockCipher_Key&,
                     const BlockCipherModeIV&);
      CTS_Decryption(const std::string&, const BlockCipher_Key&,
                     const BlockCipherModeIV&);
   private:
      void decrypt(const byte[]);
      SecureVector<byte> temp;
   };

}

#endif
