/*************************************************
* EME1 Header File                               *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_EME1_H__
#define OPENCL_EME1_H__

#include <opencl/pk_misc.h>

namespace OpenCL {

/*************************************************
* EME1                                           *
*************************************************/
class EME1 : public EME
   {
   public:
      u32bit maximum_input_size(u32bit) const;

      EME1(const std::string&, const std::string& = "MGF1",
           const std::string& = "");
      EME1(HashFunction*, MGF* = 0, const std::string& = "");
      ~EME1() { delete mgf; }
   private:
      SecureVector<byte> pad(const byte[], u32bit, u32bit) const;
      SecureVector<byte> unpad(const byte[], u32bit, u32bit) const;
      const u32bit HASH_LENGTH;
      SecureVector<byte> Phash;
      MGF* mgf;
   };

}

#endif
