/*************************************************
* EMSA2 Header File                              *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_EMSA2_H__
#define OPENCL_EMSA2_H__

#include <opencl/pk_misc.h>

namespace OpenCL {

/*************************************************
* EMSA2                                          *
*************************************************/
class EMSA2 : public EMSA
   {
   public:
      EMSA2(HashFunction*);
      EMSA2(const std::string&);
      ~EMSA2() { delete hash; }
   private:
      void update(const byte[], u32bit);
      SecureVector<byte> encoding_of(const byte[], u32bit, u32bit);
      SecureVector<byte> raw_data();
      SecureVector<byte> empty_hash;
      HashFunction* hash;
      byte hash_id;
   };

}

#endif
