/*************************************************
* EMSA3 Header File                              *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_EMSA3_H__
#define OPENCL_EMSA3_H__

#include <opencl/pk_misc.h>

namespace OpenCL {

/*************************************************
* EMSA3                                          *
*************************************************/
class EMSA3 : public EMSA
   {
   public:
      EMSA3(HashFunction*);
      EMSA3(const std::string&);
      ~EMSA3() { delete hash; }
   private:
      void update(const byte[], u32bit);
      SecureVector<byte> encoding_of(const byte[], u32bit, u32bit);
      SecureVector<byte> raw_data();
      HashFunction* hash;
      SecureVector<byte> hash_id;
   };

}

#endif
