/*************************************************
* Lookup Table Management Header File            *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_LOOKUP_MANGEMENT_H__
#define OPENCL_LOOKUP_MANGEMENT_H__

#include <opencl/base.h>
#include <opencl/mode_pad.h>

namespace OpenCL {

/*************************************************
* Add an algorithm to the lookup table           *
*************************************************/
void add_algorithm(BlockCipher*);
void add_algorithm(StreamCipher*);
void add_algorithm(HashFunction*);
void add_algorithm(MessageAuthenticationCode*);
void add_algorithm(BlockCipherModePaddingMethod*);

/*************************************************
* Add an alias for an algorithm                  *
*************************************************/
void add_alias(const std::string&, const std::string&);

/*************************************************
* Destroy the lookup tables                      *
*************************************************/
void destroy_lookup_tables();

}

#endif
