/*************************************************
* Luby-Rackoff Header File                       *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_LUBY_RACKOFF_H__
#define OPENCL_LUBY_RACKOFF_H__

#include <opencl/base.h>

namespace OpenCL {

/*************************************************
* Luby-Rackoff                                   *
*************************************************/
class LubyRackoff : public BlockCipher
   {
   public:
      void clear() throw() { K1.clear(); K2.clear(); }
      std::string name() const { return "LubyRackoff(" + hash->name() + ")"; }
      BlockCipher* clone() const { return new LubyRackoff(hash->name()); }
      LubyRackoff(const std::string&);
      ~LubyRackoff() { delete hash; }
   private:
      void enc(const byte[], byte[]) const;
      void dec(const byte[], byte[]) const;
      void key(const byte[], u32bit);
      HashFunction* hash;
      SecureVector<byte> K1, K2;
   };

}

#endif
