/*************************************************
* Miller-Rabin Tester Header File                *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_MILLER_RABIN_H__
#define OPENCL_MILLER_RABIN_H__

#include <opencl/bigint.h>
#include <opencl/reducer.h>

namespace OpenCL {

/*************************************************
* Miller-Rabin Primality Tester                  *
*************************************************/
class MillerRabin_Test
   {
   public:
      bool passes_test(const BigInt&);

      MillerRabin_Test(const BigInt&);
      ~MillerRabin_Test() { delete reducer; }
   private:
      BigInt n, r, n_minus_1;
      u32bit s;
      ModularReducer* reducer;
   };

}

#endif
