/*************************************************
* BigInt Algorithms Header File                  *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_MPCORE_H__
#define OPENCL_MPCORE_H__

#include <opencl/mp_types.h>

extern "C" {

using OpenCL::word;
using OpenCL::dword;
using OpenCL::u32bit;
using OpenCL::s32bit;
//using OpenCL::MP_WORD_MAX;
//using OpenCL::MP_WORD_BITS;
using OpenCL::MP_RADIX;

using OpenCL::u64bit; // fixme: should not be here

void bigint_add3(word* const, const word*, u32bit, const word*, u32bit);
void bigint_sub3(word* const , const word*, u32bit, const word*, u32bit);
void bigint_mul3(word* const, const word*, u32bit, const word*, u32bit);
void bigint_linmul3(word* const, const word*, u32bit, word);

void bigint_shl1(word*, u32bit, u32bit, u32bit);
void bigint_shl2(word*, const word*, u32bit, u32bit, u32bit);

void bigint_shr1(word*, u32bit, u32bit, u32bit);
void bigint_shr2(word*, const word*, u32bit, u32bit, u32bit);

bool bigint_divcore(word, word, word, word, word, word);

s32bit bigint_cmp(const word*, u32bit, const word*, u32bit);

}

#endif
