/*************************************************
* Low Level MPI Types Header File                *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_MPI_TYPES_H__
#define OPENCL_MPI_TYPES_H__

#include <opencl/config.h>

namespace OpenCL {

#if (MP_WORD_BITS == 8)
  typedef byte word;
  typedef u16bit dword;

  #define MP_WORD_MAX 0xFF
  #define MP_WORD_TOP_BIT 0x80
  const dword MP_RADIX = 0x100;
#elif (MP_WORD_BITS == 16)
  typedef u16bit word;
  typedef u32bit dword;

  #define MP_WORD_MAX 0xFFFF
  #define MP_WORD_TOP_BIT 0x8000
  const dword MP_RADIX = 0x10000;
#elif (MP_WORD_BITS == 32)
  typedef u32bit word;
  typedef u64bit dword;

  #define MP_WORD_MAX 0xFFFFFFFF
  #define MP_WORD_TOP_BIT 0x80000000
  const dword MP_RADIX = 0x100000000;
#else
  #error MP_WORD_BITS must be 8, 16, or 32
#endif

}

#endif
