/*************************************************
* Memory Mapping Allocator Header File           *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/manalloc.h>
#include <utility>
#include <vector>
#include <map>

#ifndef OPENCL_EXT_MMAP_ALLOCATOR_H__
#define OPENCL_EXT_MMAP_ALLOCATOR_H__

namespace OpenCL {

/*************************************************
* Memory Mapping Allocator                       *
*************************************************/
class MemoryMapping_Allocator : public ManagedAllocator
   {
   public:
      SecureAllocator* clone() { return this; }

      MemoryMapping_Allocator(const std::string& = "", bool = false);
      ~MemoryMapping_Allocator();
   private:
      struct Mapped_Buffer { void* buf; u32bit length; int fd; };

      void* alloc_block(u32bit) const;
      void dealloc_block(void*, u32bit) const;
      u32bit getpagesize() const;
      std::string temp_dir(const std::string&) const;
      void* mmap_block(u32bit) const;
      void munmap_block(void*, u32bit, int) const;

      const bool paranoid;
      const std::string path;
      mutable std::map<void*, std::pair<int, u32bit> > allocated;
      mutable std::vector<Mapped_Buffer> cache;
   };

}

#endif
