/*************************************************
* BigInt Constants Source File                   *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/bigint.h>
#include <opencl/numthry.h>
#include <opencl/rng.h>

namespace OpenCL {

namespace {

BigInt* zero_integer;
BigInt* one_integer;
BigInt* ten_integer;

}

/*************************************************
* Internal startup/shutdown functions            *
*************************************************/
extern void destroy_dl_groups();

/*************************************************
* Create the global constant BigInts             *
*************************************************/
void create_global_bigints()
   {
   zero_integer = new BigInt(0);
   one_integer  = new BigInt(1);
   ten_integer  = new BigInt(10);
   }

/*************************************************
* Delete the global constant BigInts             *
*************************************************/
void delete_global_bigints()
   {
   destroy_dl_groups();
   delete zero_integer;
   delete one_integer;
   delete ten_integer;
   }

/*************************************************
* Return zero                                    *
*************************************************/
const BigInt& BigInt::zero()
   {
   return (*zero_integer);
   }

/*************************************************
* Return one                                     *
*************************************************/
const BigInt& BigInt::one()
   {
   return (*one_integer);
   }

/*************************************************
* Return ten                                     *
*************************************************/
const BigInt& BigInt::ten()
   {
   return (*ten_integer);
   }

}
