/*************************************************
* EMSA-Raw Source File                           *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/emsa_raw.h>

namespace OpenCL {

/*************************************************
* EMSA-Raw Encode Operation                      *
*************************************************/
void EMSA_Raw::update(const byte input[], u32bit length)
   {
   message.append(input, length);
   }

/*************************************************
* Return the raw (unencoded) data                *
*************************************************/
SecureVector<byte> EMSA_Raw::raw_data()
   {
   SecureVector<byte> buf(message, message.size());
   message.destroy();
   return buf;
   }

/*************************************************
* EMSA-Raw Encode Operation                      *
*************************************************/
SecureVector<byte> EMSA_Raw::encoding_of(const byte msg[], u32bit msg_len,
                                         u32bit)
   {
   return SecureVector<byte>(msg, msg_len);
   }

}
