/*************************************************
* KDF Retrieval Source File                      *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/look_pk.h>
#include <opencl/lookup.h>
#include <opencl/kdf1.h>
#include <opencl/kdf2.h>

namespace OpenCL {

/*************************************************
* Get an KDF by name                             *
*************************************************/
KDF* get_kdf(const std::string& kdf)
   {
   std::vector<std::string> name = parse_algorithm_name(kdf);
   if(name.size() != 2)
      throw Invalid_Argument("Invalid KDF name: " + kdf);

   const std::string kdf_name = deref_alias(name[0]);
   const std::string hash_name = name[1];

   if(kdf_name == "KDF1")
      return new KDF1(hash_name);
   if(kdf_name == "KDF2")
      return new KDF2(hash_name);
   throw Algorithm_Not_Found(kdf);
   }

}
