/*************************************************
* MGF Retrieval Source File                      *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/look_pk.h>
#include <opencl/lookup.h>
#include <opencl/mgf1.h>

namespace OpenCL {

/*************************************************
* Get a MGF by name                              *
*************************************************/
MGF* get_mgf(const std::string& mgf)
   {
   std::vector<std::string> name = parse_algorithm_name(mgf);
   if(name.size() != 2)
      throw Invalid_Argument("Invalid MGF name: " + mgf);

   const std::string mgf_name = deref_alias(name[0]);
   const std::string hash_name = name[1];

   if(mgf_name == "MGF1")
      return new MGF1(hash_name);
   throw Algorithm_Not_Found(mgf);
   }

}
