/*************************************************
* Misc MP Functions Source File                  *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/mp_core.h>

extern "C" {

/*************************************************
* Division Core                                  *
*************************************************/
bool bigint_divcore(word q, word y_1, word y_2,
                    word x1, word x2, word x3)
   {
   dword product = (dword)q * y_2;
   y_2 = (product & MP_WORD_MAX);

   product = (dword)q * y_1 + ((product >> MP_WORD_BITS) & MP_WORD_MAX);
   y_1 = (product & MP_WORD_MAX);
   word last = (product >> MP_WORD_BITS) & MP_WORD_MAX;

   if(last > x1) return true;
   if(last < x1) return false;
   if(y_1 > x2)  return true;
   if(y_1 < x2)  return false;
   if(y_2 > x3)  return true;
   if(y_2 < x3)  return false;
   return false;
   }

/*************************************************
* Compare                                        *
*************************************************/
s32bit bigint_cmp(const word* x, u32bit x_size,
                  const word* y, u32bit y_size)
   {
   if(x_size < y_size) { return (-bigint_cmp(y, y_size, x, x_size)); }

   while(x_size > y_size)
      {
      if(x[x_size-1])
         return 1;
      x_size--;
      }
   for(u32bit j = x_size; j > 0; j--)
      {
      if(x[j-1] > y[j-1]) return 1;
      if(x[j-1] < y[j-1]) return -1;
      }
   return 0;
   }

}
