/*************************************************
* OpenCL Version Information                     *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/version.h>
#include <opencl/util.h>

namespace OpenCL {

/*************************************************
* Return the version as a string                 *
*************************************************/
std::string version_string()
   {
   return "OpenCL " + to_string(version_major()) + "." +
                      to_string(version_minor()) + "." +
                      to_string(version_patch());
   }

/*************************************************
* Return parts of the version as numbers         *
*************************************************/
u32bit version_major() { return OPENCL_VERSION_MAJOR; }
u32bit version_minor() { return OPENCL_VERSION_MINOR; }
u32bit version_patch() { return OPENCL_VERSION_PATCH; }

}
